import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:workflow/utils/date_format_util.dart';

import 'log_utils.dart';

/// 单行日志展示控件
class LogItemWidget extends StatelessWidget {
  final WBLogRecord model;

  const LogItemWidget({Key key, this.model}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    var text =
        '${DateFormatter.stringWithDateString(dateStr: model.time)} ${model.level}  ${model.message}';
    return Container(
      padding: EdgeInsets.only(left: 10, right: 10, top: 10),

      /// 复制待优化，使用TextField有矛盾处：可修改，设为只读时有不可复制
      /// SelectableText 有bug, flutter-web不支持
      child: TextField(
          toolbarOptions: ToolbarOptions(copy: true, selectAll: true),
          controller: TextEditingController(text: text),
          style: textStyle(model.level),
          keyboardType: TextInputType.multiline,
          maxLines: null,
          decoration: InputDecoration.collapsed(hintText: ''),
          onChanged: (s) {
            //setState(() {});
          }),
    );
  }

  TextStyle textStyle(String level) {
    if (level == WBLevel.INFO) {
      return TextStyle(color: Colors.white70, fontSize: 13);
    } else if (level == WBLevel.ERROR) {
      return TextStyle(color: Colors.red[400], fontSize: 13);
    } else if (level == WBLevel.SUCCESS) {
      return TextStyle(color: Colors.green[700], fontSize: 13);
    } else if (level == WBLevel.WARNING) {
      return TextStyle(color: Colors.yellow, fontSize: 13);
    } else {
      return TextStyle(color: Colors.white70, fontSize: 13);
    }
  }
}
